/********************************************************/
/*                      errcode.h                       */
/* ---------------------------------------------------- */
/* Guig                                                 */
/********************************************************/
/*
 * CVS log:
 *
 * $Author: gravier $
 * $Date: 1999/07/21 10:29:40 $
 * $Revision: 1.4 $
 *
 */
/* errcode.h: output status error code definitions.
 *
 * 0 is returned when no errors occur
 *
 * Error codes from    1 to  999 are reserved for standards errors.
 *
 * Error codes from 1000 to 1999 are reserved for SPro
 * Error codes from 2000 to 2999 are reserved for RField
 * Error codes from 3000 to 3499 are reserved for VQ
 * Error codes from 3500 to 3599 are reserved for DTW
 * Error codes from 3600 to 3699 are reserved for SExt
 * Error codes from 3700 to 3799 are reserved for SWav
 * Error codes from 4000 to 4999 are reserved for SRec
 * Error codes from 5000 to 5999 are reserved for SMath
 *
 * I put those remainder there so that I don't get confused but
 * that's of no use for anyone...
 *
 * Guig.
 */

#ifndef _errcode_h_
#define _errcode_h_

     /* --------------------------- */
     /* ----- A usefull macro ----- */
     /* --------------------------- */

#define DONE return(OK)

     /* ------------------------------ */
     /* ----- Global error codes ----- */
     /* ------------------------------ */

#define OK                 0    /* Do I explain what it means ?             */
#define ARGS_ERR          10    /* Exit status of function usage()          */
/*
 * File handling generic errors
 */
#define FILE_ERR          20    /* File unreferenced error                  */
#define FOPEN_ERR         21    /* File open error                          */     
#define LOAD_ERR          22    /* Error loading a file                     */
#define DUMP_ERR          23    /* Error dumping data to a file             */
/*
 * Allocation errors
 */
#define ALLOC_ERR         30    /* memory allocation impossible             */
/*
 * Some other errors
 */
#define RANGE_ERR         40    /* Out of range value in arrays             */
/*
 * Errors that should not exist!
 */
#define NYI_ERR          997    /* Not yet implemented                      */
#define ERR_ERR          998    /* gerror() function error                  */
#define XXX_ERR          999    /* Unreferenced error                       */

     /* --------------------------------- */
     /* ------ Global warning codes ----- */
     /* --------------------------------- */

#define WARN_WARN         -1    /* General purpose warning                  */
#define SEED_WARN        -10    /* NULL seed for RandInit()                 */





#endif /* _errcode_h_ */
