/********************************************************/
/*                      gerror.c                        */
/* ---------------------------------------------------- */
/* Guig                                                 */
/********************************************************/
/*
 * CVS log:
 *
 * $Author: gravier $
 * $Date $
 * $Revision: 1.1.1.1 $
 *
 */
/*
 * I copied the stuff from the Sirocco project.
 * Thanks to Francois!
 */

#define _gerror_c_

#include <stdio.h>               /* standard headers  */
#include <stdarg.h>

#include <gutil.h>               /* local headers     */
#include <gerror.h>
#include <errcode.h>

/* ------------------------------------------------------ */
/* ----- err_t gerror(const err_t,const char *,...) ----- */
/* ------------------------------------------------------ */
err_t gerror(const err_t  errnum,const char * format,...)
{
  va_list p_list;
  /* char valid_formats[]=VALID_FORMATS; */
  char msg[MAX_ERROR_LENGTH];
  char lformat[MAX_FORMAT_LENGTH];
  char * s;
  register unsigned int i;
  unsigned int fstart;
  bool_t get_type;
  
  s=msg;

  va_start(p_list,format);

  get_type=false;

  for(i=0;format[i];i++) {
    if(format[i] == FORMAT_START && get_type == false) {
      get_type=true;
      fstart=i;
    }
    else if(get_type == true && strchr(VALID_FORMATS,format[i])) {
      strncpy(lformat,format+fstart,i-fstart+1); 
      lformat[i-fstart+1]=(char)NULL;
      switch(format[i]) {
      case 'c':
	sprintf(s,lformat,(unsigned char)va_arg(p_list,int));
	break;
      case 'i':
      case 'd':
	sprintf(s,lformat,va_arg(p_list,int));
	break;
      case 'e':
      case 'E':
      case 'f':
      case 'g':
      case 'G':
	sprintf(s,lformat,va_arg(p_list,double));
	break;
      case 'o':
      case 'u': 
      case 'x':
      case 'X':
	sprintf(s,lformat,(unsigned int)va_arg(p_list,int));
	break;
      case 's':
	sprintf(s,lformat,va_arg(p_list,char *));
	break;
      case '%':
	*s=format[i];
	s++;
	*s=(char)NULL;
	break;
      default:
	(void)gerror(ERR_ERR,"gerror(): invalid format specifier %c",format[i]);
	return(ERR_ERR);
	break;
      }
      while(*s)
	s++;
      get_type=false;
    }
    else {
      *s=format[i];
      s++;
    }
  }
  *s=(char)NULL;

  if(errnum > 0)
    fprintf(stderr,"\n[Error %ld] %s\n",errnum,msg);
  else
    fprintf(stderr,"[Warning %ld] %s\n",errnum,msg);
  va_end(p_list);
  return(OK);
}

#undef _gerror_c_
