/********************************************************/
/*                       gutil.h                        */
/* ---------------------------------------------------- */
/* Guig                                         Oct. 95 */
/********************************************************/
/*
 * CVS log:
 *
 * $Author: gravier $
 * $Date $
 * $Revision: 1.4 $
 *
 */
/*
 * Some usefull stuff I always use.
 * Mainly boolean type definition and argument handling 
 * functions.
 */

#ifndef _gutil_h_
#define _gutil_h_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <limits.h>
#include <ctype.h>

#include <gerror.h>
#include <errcode.h>

     /* ---------------------------- */
     /* ----- TYPE DEFINITIONS ----- */
     /* ---------------------------- */

#ifndef __Boolean__
typedef enum {false,true} bool_t;
#define __Boolean__
#endif

typedef unsigned long length_t;
typedef unsigned char sindex_t;
typedef unsigned short uindex_t;
typedef unsigned long lindex_t;
typedef struct {
  char *longopt;
  char swt;
} swtab_t;

     /* -------------------------------- */
     /* ----- CONSTANT DEFINITIONS ----- */
     /* -------------------------------- */

#define CR            0xA
#define FMT_DELIM     " "
#define FNAME_SIZE    PATH_MAX
#define MAX_FILENAME  PATH_MAX
#define MAX_BASENAME  PATH_MAX
#define MAX_PATHNAME  PATH_MAX
#define MAX_FULLNAME  PATH_MAX
#define EXT_LEN       10
#define MAXLINE       1024

#define NOSWT  0
#define STRARG 1
#define NUMARG 2
#define SWTARG 3
#define NOARG  4

#define BAD_LONG_SWT_ARG '-'

     /* ------------------------------ */
     /* ----- GLOBAL VARIABLE(S) ----- */
     /* ------------------------------ */

char *prog;       /* the program basename */

  /* ------------------------------- */
  /* ----- FUNCTION PROTOTYPES ----- */
  /* ------------------------------- */

bool_t bfscan(FILE *,char *,void *);
bool_t getline(FILE *,char *);

void ArgInit(int,char **);
void LongArgInit(int,char **,swtab_t *);
char* GetStrArg(void);
char GetSwitch(void);
float GetNumArg(void);
unsigned NextArgType(void);

long fsize(FILE *);
char *progname(char *,char *);
void fover(FILE *,...);

#define bscan(fmt,v) bfscan(stdin,fmt,v)

#ifdef _gutil_c_

bool_t IsNumArg(char *);
bool_t IsSwtArg(char *);
bool_t IsLongSwtArg(char *);
char GetLongSwitch(char *);
#define IsStrArg(s) !IsNumArg(s)

#endif /* _gutil_c_ */

#endif /* _gutil_h_ */
