#!/bin/sh
#########
#
# install libgg and libprob
#
# CVS log:
#
# $Author: gravier $
# $Date $
# $Revision: 1.2 $
#

usage()
{
  echo "`basename $0` root-dir"
  echo ""
  echo "    install include files in root-dir/include and"
  echo "    libgg.a in root-dir/lib"
  echo ""
  exit 1
}

if [ $# -ne 1 ] ; then
  usage
fi

incl_dir=$1/include
lib_dir=$1/lib

if [ ! -d "${incl_dir}" ] ; then
  echo "unexisting include directory ${incl_dir}"
  exit 1
fi
if [ ! -d "${lib_dir}" ] ; then
  echo "unexisting library directory ${lib_dir}"
  exit 1
fi


if [ -f "libgg.a" ] ; then
  echo "Copying libgg.a to ${lib_dir}"
  cp libgg.a ${lib_dir}
  echo "Copying errcode.h, gerror.h and gutil.h to ${incl_dir}"
  cp errcode.h gerror.h gutil.h ${incl_dir}
else
  echo "libgg.a not built yet (build and install again if necessary)"
fi
exit 0
