/************************************************************/
/*                        sproerr.h                         */
/*                                                          */
/*                       SPro Library                       */
/* -------------------------------------------------------- */
/* Guig                                          Sept. 1998 */
/************************************************************/
/*
 * CVS log:
 *
 * $Author: gravier $
 * $Date: 1999/12/03 13:23:45 $
 * $Revision: 1.2 $
 *
 */

/*
 * SPro error codes. 
 *
 * Error codes were previously defined in libgg/errcode.h
 */

#ifndef _sproerr_h_
#  define _sproerr_h_

     /* ---------------------------- */
     /* ----- SPro error codes ----- */
     /* ---------------------------- */

#  define SPRO_ERR        1000    /* Generic SPro error code                  */
#  define VECTOR_ID_ERR   1001    /* Invalid vector index                     */
#  define FRAME_ID_ERR    1002    /* Invalid frame index (not really an error)*/
#  define WIN_ID_ERR      1003    /* Invalid weighting window                 */
#  define PARAM_ID_ERR    1004    /* Invalid parameter identificator          */

#  define OUT_SIZE_ERR    1010    /* Not enough memory alloc. in out. struct. */

#  define EMPHCO_ERR      1020    /* Invalid emphasis coefficient             */
#  define LPC_ORDER_ERR   1021    /* Invalid LPC analysis order               */
#  define LPCC_ORDER_ERR  1022    /* Invalid LPCC order (w.r.t. LPC order)    */
#  define SPEC_RES_ERR    1023    /* Spectral resolution error                */

#  define ZERO_LGTH_ERR   1030    /* Zero length signal in FFT                */
#  define FFT_LENGTH_ERR  1031    /* FFT order is too big!                    */
#  define FBANK_ORDER_ERR 1032    /* FBANK analysis order error               */
#  define DCT_ORDER_ERR   1033    /* DCT order is out of admissible range     */
#  define DCT_LENGTH_ERR  1034    /* DCT order is too big for given input     */
#  define FREQ_BOUND_ERR  1035    /* Filter-bank min/max freq error           */

#  define CONV_ERR        1040    /* Impossible convertion                    */
#  define NULL_CONV_ERR   1041    /* No convertion in convert()               */

#  define NO_HFORMAT_ERR  1100    /* No equivalent HTK format                 */
#  define HCOMPAT_ERR     1101    /* Incompatible sizeof(param_t)             */


#  define SPH_CONV_ERR    1200    /* Error in sphere format convertion        */
#  define SPHERE_ERR      1201    /* Sphere function error                    */


     /* ------------------------------ */
     /* ----- SPro warning codes ----- */
     /* ------------------------------ */

#  define SPRO_WARN            -1000    /* Generic SPro warning code                */
#  define NULL_FRAME_WARN      -1001    /* Null  energy frame                       */
#  define OVERFLOW_WARN        -1010    /* Overflow in signal quantization          */
#  define UNDERFLOW_WARN       -1011    /* Underflow in signal quantization         */
#  define ZERO_MEAN_WARN       -1020    /* Zeroing mean of statics (dynamics exists)*/
#  define UNSTABLE_FILTER_WARN -1030    /* Unstable LP filter                       */
#  define CONVERT_WARN         -1031    /* Source and target kind are the same (!!) */
#  define CONV_FLAG_WARN       -1032    /* Invalid convertion string (unknown qualifier) */
#  define ZERO_LENGTH_WARN     -1040    /* Zero length signal                       */
#  define FFT_TRUNC_WARN       -1041    /* Truncating the signal in a FFT           */
#  define SPH_CHANNEL_WARN     -1050    /* Multi-channel sphere file                */ 

#endif
